
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace BasicSteemaTeechart
{
    public partial class Form1 : Form
    {
        Steema.TeeChart.Tools.CursorTool ct = null;
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            ct = new Steema.TeeChart.Tools.CursorTool(this.tChart1.Chart);
            ct.Active = true;
            this.tChart1.Legend.Visible = true;
            this.tChart1.Legend.Alignment = Steema.TeeChart.LegendAlignments.Top;
            this.tChart1.Legend.Title.Text= "Legend";
            this.tChart1.Legend.CheckBoxes = true;
            this.tChart1.Legend.CustomPosition = false;
            //this.tChart1.Legend.Top = 50;
            //this.tChart1.Legend.Bottom = 100;
            //this.tChart1.Legend.Left = 120;
            //this.tChart1.Panel.MarginLeft = 50;
        }

        private List<int> GetValueList(int samples, int start)
        {
            List<int> values = new List<int>();

            for (int i = 0; i < samples; i++)
            {
                int val = start + (5 * (i % 10));
                values.Add(val);
            }

            return values;
        }

        private List<Color> GetColorList(int samples, Color col)
        {
            List<Color> colList = new List<Color>();

            int j = 1;
            for (int i = 0; i < samples; i++)
            {
                //colList.Add(Color.FromArgb(j, j, j));
                colList.Add(col);
                if (j >= 244) j = 0;
                j++;
            }

            return colList;
        }

        private List<System.Drawing.Drawing2D.DashStyle> GetDSList(int samples)
        {
            //new List<System.Drawing.Drawing2D.DashStyle>(new System.Drawing.Drawing2D.DashStyle[] { System.Drawing.Drawing2D.DashStyle.Dash, System.Drawing.Drawing2D.DashStyle.DashDot, System.Drawing.Drawing2D.DashStyle.DashDotDot, System.Drawing.Drawing2D.DashStyle.Dot, System.Drawing.Drawing2D.DashStyle.Solid, System.Drawing.Drawing2D.DashStyle.Dot, System.Drawing.Drawing2D.DashStyle.Dash, System.Drawing.Drawing2D.DashStyle.Solid})
            List<System.Drawing.Drawing2D.DashStyle> dsList = new List<System.Drawing.Drawing2D.DashStyle>();

            for (int i = 0; i < samples; i++)
            {
                dsList.Add(System.Drawing.Drawing2D.DashStyle.Dash);
            }

            return dsList;
        }

        private void CreatePen(int seed, Color col, string Title)
        {
            DQLine line = new DQLine(this.tChart1.Chart);
            line.Title = Title;
            line.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.DownTriangle;
            line.Pointer.Pen.Style = System.Drawing.Drawing2D.DashStyle.Solid;
            line.ColorEachLine = true;


            line.Brush.Color = System.Drawing.Color.Brown;
            line.LinePen.Color = System.Drawing.Color.Brown;
            line.OutLine.Color = System.Drawing.Color.Brown;
            line.Marks.Callout.Arrow = line.Marks.Arrow;
            line.Marks.Callout.ArrowHead = Steema.TeeChart.Styles.ArrowHeadStyles.None;
            line.Marks.Callout.ArrowHeadSize = 8;
            line.Marks.Callout.Brush.Color = System.Drawing.Color.Black;
            line.Marks.Callout.Distance = 0;
            line.Marks.Callout.Draw3D = false;
            line.Marks.Callout.Length = 10;
            line.Marks.Callout.Style = Steema.TeeChart.Styles.PointerStyles.Triangle;
            line.Marks.Font.Shadow.Visible = false;
            line.Pointer.Brush.Color = System.Drawing.Color.Brown;
            line.Pointer.HorizSize = 2;
            line.Pointer.Pen.Color = System.Drawing.Color.Brown;
            line.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.Triangle;
            line.Pointer.VertSize = 2;
            line.Pointer.Visible = true;
            //line.Title = "Line Pen";
            line.XValues.DataMember = "X";
            line.XValues.Order = Steema.TeeChart.Styles.ValueListOrder.Ascending;
            line.YValues.DataMember = "Y";
            line.ColorEachLine = true;




            line.Pointer.Color = Color.Black;
            line.Pointer.HorizSize = 1;
            line.Pointer.VertSize = 1;
            line.Pointer.Visible = true;
            line.LinePen.Width = 1;
            DateTime wd = DateTime.Now;
            TimeSpan TwentyHours = new TimeSpan(40, 0, 0);
            TimeSpan OneHour = new TimeSpan(1, 0, 0);

            //this.tChart1.Series.Add(line);


            // Not 3D!
            this.tChart1.Aspect.View3D = false;

            wd.Subtract(TwentyHours);
            List<int> valList = GetValueList(40, seed);
            List<Color> colorList = GetColorList(40, col);
            List<System.Drawing.Drawing2D.DashStyle> dslist = GetDSList(40);
            int index = 0;
            foreach (int val in valList)
            {
                ((DQLine)line).Add(wd, val,colorList[index],dslist[index] );
                wd = wd.Add(OneHour);
                index++;

            }
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Color = Color.Pink;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Color = Color.Green;

            line.GetPointerStyle += new Steema.TeeChart.Styles.CustomPoint.GetPointerStyleEventHandler(lineSeries_GetPointerStyle);

        }

        void lineSeries_GetPointerStyle(Steema.TeeChart.Styles.CustomPoint series, Steema.TeeChart.Styles.CustomPoint.GetPointerStyleEventArgs e)
        {
                // Get the Data Quality lists for this series...
            DQLine dqSeries = series as DQLine;
            if (dqSeries != null)
            {
                Hashtable thisSeriesDQColorList = dqSeries.penColors;
                Hashtable thisSeriesDQLineStyleList = dqSeries.penStyles;
                Hashtable thisSeriesDQSamplesByIndex = dqSeries.samplesByIndex;
                Hashtable thisSeriesPrevPenColor = dqSeries.prevPenColors;

                if (thisSeriesDQColorList != null &&
                    thisSeriesDQLineStyleList != null)
                {
                    if (e.ValueIndex >= 0 &&
                        series != null &&
                        e.ValueIndex < thisSeriesDQColorList.Count &&
                        e.ValueIndex < thisSeriesDQLineStyleList.Count)
                    {

                        int nextIndex = e.ValueIndex + 1;
                        if (nextIndex < (series.LastVisibleIndex + 1))
                        {

                            {
                                series.Pointer.Color = (Color)thisSeriesDQColorList[thisSeriesDQSamplesByIndex[nextIndex]];
                                series.Pointer.Pen.Color = series.Pointer.Color;
                                series.Color = series.Pointer.Color;
                                series.LinePen.Style = (System.Drawing.Drawing2D.DashStyle)thisSeriesDQLineStyleList[thisSeriesDQSamplesByIndex[nextIndex]];
                            }
                        }
                        else if (nextIndex == (series.LastVisibleIndex + 1))
                        {
                            {
                                series.Pointer.Color = (Color)thisSeriesDQColorList[thisSeriesDQSamplesByIndex[series.FirstVisibleIndex]];
                                series.Pointer.Pen.Color = series.Pointer.Color;
                                series.Color = series.Pointer.Color;
                                series.LinePen.Style = (System.Drawing.Drawing2D.DashStyle)thisSeriesDQLineStyleList[thisSeriesDQSamplesByIndex[series.FirstVisibleIndex]];
                            }
                        }
                        else
                        {
                            //NO Match
                        }
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //CreatePen(0, Color.Red);
            CreatePen(30, Color.Green, "PEN1");
            CreatePen(60, Color.Yellow, "PEN2");
            CreatePen(60, Color.Yellow, "PEN3");
            CreatePen(60, Color.Yellow, "PEN4");
            CreatePen(60, Color.Yellow, "PEN5");
            CreatePen(60, Color.Yellow, "PEN6");
            CreatePen(60, Color.Yellow, "PEN7");
            CreatePen(60, Color.Yellow, "PEN8");
            CreatePen(60, Color.Yellow, "PEN9");
            CreatePen(60, Color.Yellow, "PEN10");
            CreatePen(60, Color.Yellow, "PEN11");
            CreatePen(60, Color.Yellow, "PEN12");
            //CreatePen(90, Color.Blue);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //this.tChart1.Series[0].Clear();
            //this.tChart1.Series[1].Clear();
            //this.tChart1.Series[2].Clear();
            //this.tChart1.Series[3].Clear();
            this.tChart1.Series.Clear();
        }
    }
}